/*
  Criado por:
    Alex Crispim - UNA-SUS/BSB
    Nayara Rossi - UNA-SUS/BSB
  Arquivo JS principal do curso
*/

//Variável iniciada antes do carregamento completo da página para verificar o uso dos botões voltar e avançar do navegador
var firstload = true;

const pagInicial = "menu01&pagina01";

/*Função do Browser que acrescenta a página do index no Ajax como primeira página do histórico do navegador*/
window.history.replaceState(pagInicial, null, "index.html#"+ pagInicial);

$(function() {
  "use strict";
  /*Evita que links vazios realizem ações*/
  $(document).on("click", "a[href='#'], a[href=''], a[data-toggle='modal']", function (e) {
    e.preventDefault();
  });
  /*Função que carrega a estrutura do menu principal e topo das páginas via Ajax*/
  carregarEstrutura();
  /*Função que verifica as variáveis do PPU*/
  utilizarPPU();
  /*Função que carrega a página inicial via ajax utilizando o documento conteudoCurso.json*/
  carregadorPagina(pagInicial);
  /*Código para navegar por setas do teclado direita/esquerda - avançar/voltar*/
  var pressedShift = false;
  $(document).on("keyup", function (e) {//O evento Keyup é acionado quando as teclas são soltas
    var keyCode = e.keyCode || e.which;
    if (keyCode === 16) {
      pressedShift = false; //Quando qualquer tecla for solta é preciso informar que shift não está pressionada
    }
  });
  $(document).on("keydown", function (e) {
    if (!$("textarea").is(":focus")){
      var keyCode = e.keyCode || e.which;
      if (keyCode === 16) {
        pressedShift = true;//Informando que shift está acionado
      }
      if (keyCode === 37 && pressedShift !== true) {
        //Seta esquerda
        $("[data-navegacao='prevPage']")[0].click();
      }
      if (keyCode === 39 && pressedShift !== true) {
        //Seta direita
        $("[data-navegacao='nextPage']")[0].click();
      }
    }
  });
  /*Navegação do curso e manipulação de histórico de navegação para utilização em qualquer link*/
  $(document).on("click", ".carregarPagina", function () {
    let link = $(this).attr("href").substr($(this).attr("href").lastIndexOf("#") + 1);
    //Elimina links vazios
    if (link !== "") {
      //Acrescenta ao link clicado o início obrigatório e o href via json
      if (!$(this).attr("href").match(/index.html#/)) {
        $(this).attr("href", "index.html#" + link);
      }
      /*Função do Browser que acrescenta a página Ajax ao histórico do navegador*/
      window.history.pushState(link, null, this.href);
      /*Função que carrega a página via ajax utilizando o documento conteudoCurso.json*/
      carregadorPagina(link);
    } else {
      return false;
    }
  });
  /**/
  /*Função que carrega os dados que são mostrados na modal*/
  carregarModal();
  //Função para acesso rápido as páginas para o DESENVOLVIMENTO.
  if (window.location.href.search("localhost:8080") > 1) {
    //Função que troca o número da página por um campo de input para acesso rápido ao conteúdo
    $(document).on("dblclick", "#numPagina", function (e) {
      $('#numPagina strong').replaceWith('<input id="novaPagina" maxlength="2" type="text" data-pagina="' + $('#numPagina strong').text() + '" style="width:25px; border: 1px solid black;"></input>');
      $("#novaPagina").focus();
    });
    //Função que recebe o numero da pagina do Easter Egg e manda para a determinada página, caso essa pertença ao menu, caso contrário somente fecha essa opção
    $(document).on('keydown', '#novaPagina', function (e) {
      let key = e.which || e.keyCode;
      let pagina = "";
      //Variável usada para verificar a pagina atual
      let paginaAtual = $("#novaPagina").attr('data-pagina');
      if (key == 13) {//Código para executar se pressionada a tecla enter
        //Variável que seleciona o menu atual
        let menu = window.location.href.substring(window.location.href.lastIndexOf("#") + 1, window.location.href.lastIndexOf("&") + 7);
        //Verifica se o valor adicionado no input foi maior que 10
        if (parseInt(this.value, 10) < 10) {
          pagina = menu + "0" + this.value;
        }
        else {
          pagina = menu + this.value;
        }
        //Verifica se a página desejada está dentro da quantidade de páginas do menu atual
        if (parseInt(this.value, 10) > parseInt($("#numPagina").html(), 10)) {
          $('#numPagina input').replaceWith('<strong class="h3">' + paginaAtual + '<strong/>');
        }
        else {
          carregadorPagina(pagina);
        }
      }
    });
  }
  /**/
  //Código para fechar menu ao clicar fora da sua área em resolução menor que 992
  $(document).on("click", "#content, .menu-sidebar .carregarPagina", function () {
    let janela = window.innerWidth;
    if ($("#sidebar").hasClass("active") && janela <= 992) {
      $(".sidebarCollapse").trigger("click");
      $(".left-control").css("left", 0);
    }
  });
  //Código fecha o menu de cima ao clicar no conteudo principal
  $(document).on("click", "#conteudoPrincipal, .carregarPagina, [data-toggle = 'modal']", function(){
    let janela = window.innerWidth;
    if ($(".navbar-collapse").attr("aria-expanded") === "true" && janela <= 992) {
      $(".navbar-toggle").trigger("click");
    }
  });

  /**/
  //Código para manipular a modal do vídeo
  $(document).on("click", ".videoInfor", function () {
    $(this).siblings(".videoContainer").children(".downloadVideo").hide();
    $(this).siblings(".videoContainer").children(".resolucaoVideo").toggle();
  });
  $(document).on("click", ".videoDownload", function () {
    $(this).siblings(".videoContainer").children(".resolucaoVideo").hide();
    $(this).siblings(".videoContainer").children(".downloadVideo").toggle();
  });
  $(document).on("click", ".fecharResolucao, .downloadVideo .downloadArquivo", function () {
    $(this).parents(".videoContainer").children(".resolucaoVideo, .downloadVideo").hide();
  });
  //Código para manipular a modal do dragndrop
  $(document).on("click", ".closeModal", function () {
    $("#modalComponente, .dragBack").remove();
  });
  /*Função para trocar a resolução do video de acordo com a escolha do usuário*/
  $(document).on("click", "#qualidade .escolha", function () {
    var resolucao = $(this).attr("data-resolucao");
    var idVideo = $(this).parents(".videoContainer").children("video").attr("id");
    var video = $("#"+ idVideo +" source").attr("data-video");
    $("#"+ video).empty();
    $("#"+ video).html('<source src="assets/videos/' + video + '_' + resolucao + '.mp4" type="video/mp4" data-video="' + video + '" />');
    //Recarrega o vídeo e continua no mesmo tempo
    var src = document.getElementById(idVideo);

    src.pause();
    var tempo = src.currentTime;
    src.load();
    //Fix para o Chrome não apresentar erro no console, não compatível com IE
    /*var playPromise = src.play();
    if (playPromise !== undefined){
      playPromise.then(_ => {
      }).catch(error => {
        src.currentTime = tempo;
        src.play();
      });
    }*/
    src.currentTime = tempo;
    src.play();
    $(".resolucaoVideo, .downloadVideo").hide();
    configurarQualidadeVideo(resolucao);
  });
  //Código para abrir o primeiro tópico ao clicar na unidade
  $(document).on("click", ".menu-link a", function () {
    if ($(this).attr("aria-expanded") === "true") {
      $(this).siblings("ul").children("li").children("a").first().trigger("click");
    }
  });
  //Código para alternativa de baixar arquivos em navegadores IE <= 11 e incompatíveis com atributo "download" de acordo com o site: https://caniuse.com/#search=download%20attribute
  $(document).on("click", "a[href$='.pdf']", function () {
    $(this).attr('target', '_blank');
  });
  //Sobe página para o topo quando clica nas setas
  $(document).on("click", "[data-navegacao='nextPage'], [data-navegacao='prevPage']", function () {
    $('html, body').animate({ scrollTop: 0 }, 'fast');
  });
  //Verifica links que abrem uma modal com conteúdo
  $(document).on("click", ".modalLink", function() {
    let local = $(this).parents("[data-componente]");
    let componente = local.data("componente");
    let textoModal = $(this).data("texto");
    montarModal(componente, textoModal);
  });
});//Fim do ready

/*Funções*/

function separarEndereco(endereco) {
  let navegacao, unidade, menu, pagina;
  //Caso a página passada seja uma url completa esta váriavel separa a página da url
  navegacao = endereco.substr(endereco.lastIndexOf("#") + 1);

  if(navegacao.split("&")[0].startsWith("u")){
    unidade = navegacao.split("&")[0];
    menu = navegacao.split("&")[1];
    pagina = navegacao.split("&")[2];
  } else {
    menu = navegacao.split("&")[0];
    pagina = navegacao.split("&")[1];
  }
  return {unidade, menu, pagina};
}

/*Função para Utilização de variáveis de PPU*/
function utilizarPPU(buscarPagina) {
  let navegacao, unidade, menu, pag;
  //Verifica se é o primeiro carregamento ou não pela ausência do parâmetro
  if(buscarPagina){
    navegacao = separarEndereco(buscarPagina);
    unidade = navegacao.unidade;
    menu = navegacao.menu;
    pag = navegacao.pagina;
  }
  if(pag !== "paginaProgresso"){
    /*Verifica se os parâmetros existem, pois ele já está recarregando via Ajax para atualizar a variável STATUS do PPU*/
    if (buscarPagina) {
      let conteudoPPU;
      //Variável para impedir gravações desnecessárias no PPU
      let status_change = false;
      //Variável que contém uma instância da STATUS
      let status = unasus.pack.getStatus();

      if(unidade){
        conteudoPPU = status.conteudoPPU[unidade];
      } else {
        conteudoPPU = status.conteudoPPU;
      }
      //Inicializa os contadores para verificação dos menus, módulos e páginas visitadas e concluídas
      let contadorMenu = 0;
      let contadorPag = 0;
      //Código para retirar número da página
      let posPag = pag.substring(6, 8);
      //Verifica o tamanho do array do menu, retirando o índice "0" que contém a resposta da conclusão
      let tamMenu = conteudoPPU[menu].length - 1;//A subtração de menos 1 é para excluir o índice "0" que marca se já foi concluído
      let arrayQuestoes = [];
      //Retira o "0" antes dos números para acessar o índice do array, onde está a página.
      if (posPag < 10) {
        posPag = posPag.charAt(posPag.length - 1);
      }
      //Grava as páginas de conteúdo que foram visitadas
      if (conteudoPPU[menu][posPag] === 0) {
        conteudoPPU[menu][posPag] = 1;
        status_change = true;
      }
      //Laço para a contagem das páginas visitadas no menu e de questões concluídas
      for (let i = 0; i <= tamMenu; i++) {
        if (conteudoPPU[menu][i] === 1 || conteudoPPU[menu][i][0] === 1) {
          contadorPag++;
        }
      }
      //Grava na STATUS se o menu com páginas comuns foram totalmente visitados
      if (contadorPag === tamMenu && conteudoPPU[menu][0] === false){
        conteudoPPU[menu][0] = true;
        status_change = true;
      }
      //Verifica se todos os menus foram visitados
      for (let j in conteudoPPU) {
        if (j.substring(0, 4) === "menu" && conteudoPPU[j][0] === true) {
          contadorMenu++;
        }
      }
      //Ativa a gravação no PPU
      if (status_change) {
        unasus.pack.setStatus(status);
      }
      //Verifica se a página é de questão e avisa ao usuário se ele já respondeu ou não
      if(conteudoPPU[menu][posPag].length >= 2){
        arrayQuestoes = conteudoPPU[menu][posPag];
        let msgPonto = `<div class="alert alert-success animated fadeIn bloco-atividade__alerta-sucesso questaoRespondida">
          <i class="uil uil-check-circle"></i>
          <p>Você concluiu esta tarefa</p>
        </div>`;
        let msgNaoPonto = `<div class="alert alert-info animated fadeIn bloco-atividade__alerta-sucesso questaoRespondida">
          <i class="uil uil-exclamation-circle"></i>
          <p>Você não concluiu esta tarefa</p>
        </div>`;
        $(".questaoRespondida").remove();
        arrayQuestoes.forEach((idQuestao, i) => {
          i -= 1;//Exclui o primeiro índice do array.
          if(idQuestao === true){
            $("form").eq(i).parents(".tipoQuestao").prepend(msgPonto);
            if($(".dragnDrop").is(":visible")){
              $(".dragnDrop .panel-default").prepend(msgPonto);
            }
          }
          if(idQuestao === false){
            $("form").eq(i).parents(".tipoQuestao").prepend(msgNaoPonto);
            if($(".dragnDrop").is(":visible")){
              $(".dragnDrop .panel-default").prepend(msgNaoPonto);
            }
          }
        });
      }
    } else {
      /*Função para iniciar a Biblioteca UNASUS, inserir a persistência da Váriavel STATUS e receber variáveis para o Status padrão do PPU*/
      inicializarPPU({
        conteudoPPU: {//As questões possuem 2 ou mais parâmetros para atividade feita "0 ou 1" e se acertou "true ou false" Ex: [0, false, false]
          menu01: [false, 0],
          u1: {
            concluido: false,
            menu01: [false, 0, 0, 0, 0],
            menu02: [false, 0],
            menu03: [false, 0, [0, false]],
            menu04: [false, 0]
          },
          u2: {
            concluido: false,
            menu01: [false, 0, 0, 0],
            menu02: [false, 0],
            menu03: [false, 0],
            menu04: [false, 0, [0, false], [0, false]],
            menu05: [false, 0]
          },
          u3: {
            concluido: false,
            menu01: [false, 0, 0, 0, [0, false], [0, false], [0, false]],
            menu02: [false, 0],
            menu03: [false, 0, 0],
            menu04: [false, 0],
            menu05: [false, 0],
            menu06: [false, 0, 0],
            menu07: [false, 0, 0, 0],
            menu08: [false, 0],
            menu09: [false, 0],
            menu10: [false, 0],
            menu11: [false, 0, [0, false]],
            menu12: [false, 0]
          },
          u4: {
            concluido: false,
            menu01: [false, 0, 0],
            menu02: [false, 0, 0],
            menu03: [false, 0, [0, false], [0, false], [0, false]],
            menu04: [false, 0]
          }
        }
      });
      //O código a seguir cria e retira o feedback para atividade com RadioButton e insere os dados da resposta escolhida na variável de persistência ANSWER do PPU utilizando o controllerPPU.js
      $(document).on("click", ".radio input", function () {
        //Identifica o componente que será usado
        let componente = $(this).parents("[data-componente]").data("componente");
        let formulario = $(this).parents("form");
        //Atribui falso as questões clicadas
        let qCorreta = false;
        //Busca qual questionario o usuário está respondendo
        let questionario = $(this).parents("form").data("questionario");
        //Identifica o número da questão
        let idQuestao = $(this).parents("form").data("questao");
        //Verifica se a questão escolhida está correta
        formulario.find(".feedback").hide();
        formulario.find(".radio").removeClass("checked checked-correct checked-wrong");
        if ($(this).parents(".radio").children(".feedback").hasClass("alert-success")) {
          qCorreta = true;
          $(this).parents(".radio").addClass("checked checked-correct");
        } else {
          $(this).parents(".radio").addClass("checked checked-wrong");
        }
        $(this).parents(".radio").children('.feedback').show();
        /*Recebe as variáveis correspondentes a questão, alternativa e se está correta a cada escolha - PPU*/
        armazenarResposta(questionario, idQuestao, $(this).val(), qCorreta);
        if(qCorreta === true){
          //Verifica de acordo com o gabarito as questões
          verificarGabarito(componente, "radio", formulario);
        }
      });

      /*Atividade com combo*/
      //O código a seguir cria e retira o feedback para atividade com "Combo" e insere os dados da resposta escolhida na variável de persistência ANSWER do PPU utilizando o controllerPPU.js
      $(document).on("change", ".atividadeCombo .custom-forms select", function(){
        //Atribui falso as questões escolhidas
        let qCorreta = false;
        //Busca qual questionario o usuário está respondendo
        let questionario = $(this).parents('form').data("questionario");
        //Identifica qual questão pertence
        let idQuestao = $(this).parents('form').data("questao");
        //Identifica qual opção está sendo respondida
        let idItem = $(this).parent().data("item");
        //Verifica se a questão escolhida está correta
        if ($(this).parent().children('.feedback').hasClass("alert-success")) {
          qCorreta = true;
        }
        //Retira o "0" antes dos números para enviar a gravação.
        if (idItem.substring(idItem.length-2) < 10) {
          idItem = idItem.charAt(idItem.length - 1);
        } else {
          idItem = idItem.substring(idItem.length - 2);
        }
        /*Recebe as variáveis correspondentes a questão, alternativa e se está correta a cada escolha - PPU*/
        armazenarResposta(questionario, idQuestao, idItem, qCorreta);
      });
      //Código que oculta o feedback geral do formulário em atividade de "Combo" ao selecionar uma nova opção
      $(document).on("click", ".custom-forms select", function () {
        $(this).parents("form").find(".mensagemGabarito").hide();
      });
      //Código que cria o feedback para atividade de combo
      $(document).on("click", ".atividadeCombo .enviar", function () {
        //Identifica o componente que será usado
        let componente = $(this).parents("[data-componente]").data("componente");
        let formulario = $(this).parents("form");

        //Verifica se todos os itens foram escolhidos para verificar de acordo com o gabarito ou não
        let i, selectOptions = $(formulario).find("select");
        let semResposta = 0;
        for (i = 0; i < selectOptions.length; i++) {
          if(selectOptions[i][0].selected){
            semResposta++;
          }
        }
        if(semResposta !== 0){
          $("[data-componente='"+ componente +"'] .mensagemGabarito").html(`<i class="uil uil-exclamation-circle"></i><p>Você deixou itens sem responder.</p>`).removeClass("alert-danger alert-info alert-success").addClass("alert-info").show();
        } else {
          verificarGabarito(componente, "atividadeCombo", formulario);
        }
      });
      //Código para limpar o formulário do tipo "atividadeCombo"
      $(document).on("click", ".atividadeCombo .tentarNovamente", function () {
        //Identifica o formulário que precisa ser reiniciado
        let i, formulario = $(this).parents("form");
        let selectOptions = $(formulario).find("select");
        $(formulario).find(".feedback, .mensagemGabarito").hide();//Oculta os feedbacks
        //Coloca o primeiro item de cada combo como selecionado e atualiza a interface utilizando o click para isso.
        for (i = 0; i < selectOptions.length; i++) {
          $(selectOptions[i]).children("option").eq(0).prop("selected","selected").click();
        }
        //Habilita responder novamente ao questionário
        $(formulario).find("select").removeAttr("disabled");
        $(formulario).find(".enviar").show();
        $(formulario).find(".tentarNovamente").hide();
      });
      /*Fim Atividade com combo*/

      /*Atividade com checkbox*/
      //Código que cria o feedback para atividade com Checkbox
      $(document).on("click", ".atividadeCheckbox .enviar", function () {
        let componente = $(this).parents("form").attr("id");
        let formulario = $(this).parents("form");
        if(!$(formulario).find("input[type='checkbox']").is(":checked")){
          $('[data-componente="'+ componente + '"] .mensagemGabarito').html(`<i class="uil uil-exclamation-circle"></i><p>Você não selecionou nenhum item.</p>`).removeClass("alert-danger alert-warning").addClass("alert-info").show();
        } else {
          $.getJSON("assets/json/conteudoCurso.json", function (json) {
            verificarGabarito(componente, "checkbox", formulario, json);
          });
        }
      });
      //Código para limpar o formulário de checkbox
      $(document).on("click", ".atividadeCheckbox .tentarNovamente", function () {
        let formulario = $(this).parents("form");
        $(formulario).find(".checkbox").removeClass("checked checked-correct checked-wrong").show();
        $(formulario).find(".feedback").hide();
        $(formulario).find(".mensagemGabarito").hide();
        $(formulario).find("input[type='checkbox']").removeAttr("disabled").removeAttr("checked");
        $(formulario).find(".enviar").show();
        $(formulario).find(".tentarNovamente").hide();
      });
      //Código que oculta o feedback do checkbox ao selecionar uma nova opção
      $(document).on("click", ".checkbox input", function () {
        $(this).parents("form").find(".mensagemGabarito").hide();
      });
      /*Fim Atividade checkbox*/

      /*Atividade com texto*/
      //Contador de caracteres
      $(document).on("input", "form .dissertativa textarea", function (e) {
        const value = e.target.value;
        $(this).siblings("label").find("span i").html(value.length);
      });
      //Código que oculta o feedback geral do formulário em atividade de "texto" ao selecionar para digitação
      $(document).on("click", ".custom-forms textarea", function () {
        $(this).parents("form").find(".mensagemGabarito, .feedback").hide();
        $(this).parents("form").find(".enviar").show();
      });
      //Código que cria o feedback para atividade de texto
      $(document).on("click", ".atividadeTexto .enviar", function () {
        //Identifica o componente que será usado
        let componente = $(this).parents("[data-componente]").data("componente");
        let formulario = $(this).parents("form");
        let verificarResposta = $(formulario).find("textarea").val();

        if(verificarResposta == ""){
          $("[data-componente='"+ componente +"'] .mensagemGabarito").html(`<i class="uil uil-exclamation-circle"></i><p>Você ainda não digitou nada no campo de texto.</p>`).removeClass("alert-danger alert-info alert-success").addClass("alert-info").show();
        } else {
          $("[data-componente='"+ componente +"'] .mensagemGabarito").hide();
          verificarGabarito(componente, "atividadeTexto", formulario);
        }
        $(formulario).find("label span i").text("0");//Zera contador de caracteres
      });
      /*Fim Atividade com texto*/

      /*Atividade por área*/
      $(document).on("change", ".atividadeImagemArea .custom-forms select", function(){
        //Condição para não processar a primeira opção
        if (!$(this).children("option:eq(0)").is(":selected")) {
          //Atribui falso as questões escolhidas
          let qCorreta = false;
          //Busca qual questionario o usuário está respondendo
          let questionario = $(this).parents('form').data("questionario");
          //Identifica qual questão pertence
          let idQuestao = $(this).parents('form').data("questao");
          //Identifica qual opção está sendo respondida
          let idItem = $(this).parent().data("item");
          //Verifica se a questão escolhida está correta
          if ($(this).parent().children('.feedback').hasClass("alert-success")) {
            qCorreta = true;
          }
          //Retira o "0" antes dos números para enviar a gravação.
          if (idItem.substring(idItem.length-2) < 10) {
            idItem = idItem.charAt(idItem.length - 1);
          } else {
            idItem = idItem.substring(idItem.length - 2);
          }
          let componente = $(this).parents("[data-componente]").data("componente");
          let formulario = $(this).parents("form");
          /*Recebe as variáveis correspondentes a questão, alternativa e se está correta a cada escolha - PPU*/
          armazenarResposta(questionario, idQuestao, idItem, qCorreta);
          verificarGabarito(componente, "atividadeImagemArea", formulario);
        } else {
          $(this).parent().children('.feedback').hide();
        }
      });
      /*Fim Atividade por área*/

      /*Atividade com escala likert*/
      //Código que cria o feedback para atividade com escala likert
      $(document).on("click", ".atividadeLikert .enviar", function () {
        let countPerguntas = 0, countRespostas = 0;
        let componente = $(this).parents("[data-componente]").data("componente");
        let formulario = $(this).parents("form");
        let atividade = $(this).parents(".atividadeLikert");
        let questionario = formulario.attr("data-questionario");
        let idQuestao = formulario.attr("data-questao");
        let perguntas = atividade.find(".pergunta");
        for (let i = 0; i < perguntas.length; i++) {
          countPerguntas++;
          if($(perguntas[i]).attr("data-valor") !== undefined){
            countRespostas++;
          }
        }
        //Verifica se todas as perguntas foram respondidas
        if(countPerguntas === countRespostas){
          atividade.find(".mensagemGeral").hide();
          atividade.find(".pergunta input").prop("disabled","disabled");
          atividade.find(".mensagemFeedback").show();
          atividade.find(".enviar").hide();
          armazenarResposta(questionario, idQuestao, 1, true);
          verificarGabarito(componente, "likert", formulario);
        } else {
          atividade.find(".mensagemFeedback").hide();
          atividade.find(".mensagemGeral").html(`<i class="uil uil-exclamation-circle"></i><p>Você não respondeu todos os itens.</p>`).show();
        }
      });
      //Código que oculta o feedback do checkbox ao selecionar uma nova opção
      $(document).on("click", ".atividadeLikert input", function () {
        $(this).parents(".atividadeLikert").find(".mensagemGeral").hide();
      });
      /*Fim Atividade com escala likert*/

      /*Pega dinamicamente o tipo e o nome do arquivo e envia para a inserção na variável de persistência DOWNLOAD do PPU utilizando o controllerPPU.js*/
      $(document).on("click", ".downloadArquivo", function() {
        let arquivo = $(this).attr("href");
        //Adiciona o atributo download quando ele não existir no link para download
        let texto = $(this).text();
        if (!$(this).attr("download")) {
          $(this).attr("download", texto);
        }
        rastrearDownload(arquivo);
      });
      /*Pega dinamicamente a url do link e envia para a inserção na variável de persistência EXTERNAL_LINK do PPU utilizando o controllerPPU.js*/
      $(document).on("click", ".linkExterno", function() {
        $(this).attr("target", "_blank");
        let url = $(this).attr("href");
        rastrearLinkExterno(url);
      });
    }
  }
  /*Função para atualizar a status com LTI e Percentage e marcar o menu sidebar de acordo com a STATUS do PPU*/
  atualizarStatus();
}

//Função que verifica o gabarito de questões. Aceita 4 parâmetros: 1º o componente a ser verificado, 2º o tipo de questão, 3º o formulário para identificar a questão e 4º o json caso precise verificar os dados do componente
function verificarGabarito(cpnt, tipo, formulario, json) {
  //Variável que contém uma instância da STATUS
  let status = unasus.pack.getStatus();
  //Atribui falso as questões clicadas
  let qCorreta = false;
  //Variável para contar as questões respondidas corretamente
  let contadorQuestaoCerta = 0;
  //Identifica onde o usuário está neste momento
  let link = window.location.href.substr(window.location.href.lastIndexOf("#") + 1);
  //Variáveis que quebram o link recebido para buscar a página no json
  let navegacao = separarEndereco(link);
  let unidade = navegacao.unidade;
  let menu = navegacao.menu;
  let pagina = navegacao.pagina;
  //Identifica o local da questão para o posicionamento na status
  let localQuestao = pagina.substring(6);
  //Retira o "0" em páginas menores
  if(localQuestao < 10){
    localQuestao = localQuestao.charAt(1);
  }
  //Identifica qual questão pertence
  let idQuestao = formulario.data("questao");
  //Trata os itens da interface após enviar o formulário
  $("[data-componente='"+ cpnt +"'] .mensagemGabarito").removeClass("alert-success alert-danger alert-warning");
  /*São verificados de acordo com os tipos de questões e suas regras*/
  //Tipo radio
  if(tipo === "radio"){
    gravarQuestoes();
  }
  //Tipo atividades com "Combo"
  if(tipo === "atividadeCombo"){
    $("#" + cpnt + " .feedback").show();
    $("#" + cpnt + " .enviar").hide();
    $("#" + cpnt + " .item select").attr("disabled", "disabled");
    $("#"+ cpnt +" .item").removeClass("bloco-atividade__feedback-certo bloco-atividade__feedback-errado");
    let feedbacks = $("#" + cpnt + " .item .feedback");
    let i,
    corretas = 0,
    erradas = 0;
    for (i = 0; i < feedbacks.length; i++) {
      if($(feedbacks[i]).hasClass("alert-success")){
        $(feedbacks[i]).parent(".item").addClass("bloco-atividade__feedback-certo");
        corretas++;
        continue;
      }
      if($(feedbacks[i]).hasClass("alert-danger")){
        $(feedbacks[i]).parent(".item").addClass("bloco-atividade__feedback-errado");
        erradas++;
        continue;
      }
    }
    //Verifica os itens corretos escolhidos e o gabarito para feedback personalizado
    if(corretas === feedbacks.length){
      $("[data-componente='"+ cpnt +"'] .mensagemGabarito").html('<i class="uil uil-exclamation-circle"></i><p>Parabéns você acertou essa questão!</p>').addClass("alert-success").show();
      $("#" + cpnt + " .btnResponder").hide();
      gravarQuestoes();
    } else {
      $("[data-componente='"+ cpnt +"'] .mensagemGabarito").html('<i class="uil uil-exclamation-circle"></i><p>Você não acertou o que é necessário para essa questão. Tente novamente.</p>').addClass("alert-danger").show();
      $("#" + cpnt + " .tentarNovamente").show();
    }
  }
  //Tipo Drag'nDrop
  if(tipo === "dragndrop"){
    gravarQuestoes();
  }
  //Tipo Checkbox
  if(tipo === "checkbox"){
    $("#" + cpnt + " .feedback").show();
    $("#" + cpnt + " .enviar").hide();
    //Variáveis para manipular as respostas do checkbox
    let item, idItem, respostas = [];
    //Variáveis para manipular os acertos e erros
    let i, gabarito, corretas = 0, erradas = 0;
    //Busca o gabarito da questão no Json
    if(unidade){
      gabarito = json.conteudoPrincipal[unidade][menu][pagina][cpnt].correta;
    } else {
      gabarito = json.conteudoPrincipal[menu][pagina][cpnt].correta;
    }
    //Verifica todos os itens de checkbox e armazena os itens que foram marcados pelo usuário.
    let itensForm =	formulario.find("input[type='checkbox']");
    $("#" + cpnt + " .checkbox").hide();
    for (item = 0; item < itensForm.length; item++) {
      if($(itensForm[item]).is(":checked")){
        idItem = $(itensForm[item]).data("item");
        respostas.push(idItem);
        $("#" + cpnt + " .checkbox." + idItem).show();
      }
    }
    //Verifica os itens corretos entre o gabarito e as escolhas do usuário
    if(Array.isArray(gabarito) && gabarito.length === 0){//Para questionário que não tenha certo ou errado é utilizado um array vazio.
      respostas.map(item => {
        $("#" + cpnt + " ." + item + " .feedback").removeClass("alert-danger").addClass("alert-success").children("strong").html('<i class="uil uil-file-check-alt"></i> Muito bem');
      });
    } else {
      gabarito.filter(acerto => {
        if(respostas.includes(acerto)){
          $("#" + cpnt + " ." + acerto + " .feedback").removeClass("alert-danger").addClass("alert-success");
        }
      });
    }
    let feedbacks = $("#" + cpnt + " .checkbox .feedback");
    let questionario = formulario.data("questionario");
    let idQuestao = formulario.data("questao");
    for (i = 0; i < feedbacks.length; i++) {
      if($(feedbacks[i]).is(":visible")){
        let valorInput = $(feedbacks[i]).siblings("label").children("input").val();
        if($(feedbacks[i]).hasClass("alert-success")){
          $(feedbacks[i]).parent(".checkbox").addClass("checked checked-correct");
          corretas++;
          armazenarResposta(questionario, idQuestao, valorInput, true);
          continue;
        }
        if($(feedbacks[i]).hasClass("alert-danger")){
          $(feedbacks[i]).parent(".checkbox").addClass("checked checked-wrong");
          erradas++;
          armazenarResposta(questionario, idQuestao, valorInput, false);
          continue;
        }
      }
    }
    //Trata os itens da interface após enviar o formulário
    $("#" + cpnt + " input[type='checkbox']").attr("disabled", "disabled");
    //Verifica os itens corretos escolhidos e o gabarito para feedback personalizado. Se gabarito vazio, aceita qualquer resposta.
    if((corretas === gabarito.length && erradas === 0) || gabarito.length === 0){
      $("[data-componente='"+ cpnt +"'] .mensagemGabarito").html('<i class="uil uil-exclamation-circle"></i><p>Parabéns você acertou essa questão!</p>').addClass("alert-success").show();
      $("#" + cpnt + " .enviar").hide();
      gravarQuestoes();
    } else {
      $("[data-componente='"+ cpnt +"'] .mensagemGabarito").html('<i class="uil uil-exclamation-circle"></i><p>Você não acertou o que é necessário para essa questão. Tente novamente.</p>').addClass("alert-danger").show();
      $("#" + cpnt + " .tentarNovamente").show();
    }
  }
  //Tipo atividadeTexto
  if(tipo === "atividadeTexto"){
    let questionario = formulario.data("questionario");
    let idQuestao = formulario.data("questao");
    let texto = $("#" + cpnt + " .dissertativa textarea").val();
    $("#" + cpnt + " .feedback").show();
    $("[data-componente='"+ cpnt +"'] .mensagemGabarito").html('<i class="uil uil-exclamation-circle"></i><p>Você respondeu essa questão!</p>').addClass("alert-success").show();
    $("#" + cpnt + " .enviar").hide();
    usarAnotacaoPPU("dissertativa", questionario +"_questao"+ idQuestao, texto, 500);
    $("#" + cpnt + " .dissertativa textarea").val("");
    gravarQuestoes();
  }
  //Tipo atividades imagem por área
  if(tipo === "atividadeImagemArea"){
    let idQuestao = formulario.data("questao");
    let option = $("#" + cpnt + "_questao"+ idQuestao +" .item select option:selected").val();
    let resposta = $("#" + cpnt + "_questao"+ idQuestao +" .item select").attr("data-resposta");
    $("#" + cpnt + "_questao"+ idQuestao +" .feedback").show();
    $("#" + cpnt + "_questao"+ idQuestao +" .item").removeClass("bloco-atividade__feedback-certo bloco-atividade__feedback-errado");
    if(resposta === option){
      $("#" + cpnt + "_questao"+ idQuestao +" .item").addClass("bloco-atividade__feedback-certo");
      gravarQuestoes();
    } else {
      $("#" + cpnt + "_questao"+ idQuestao +" .item").addClass("bloco-atividade__feedback-errado");
    }
  }
  //Tipo likert
  if(tipo === "likert"){
    gravarQuestoes();
  }
  /*Função que verifica e grava as questões na STATUS do PPU de acordo com a regra para questões */
  function gravarQuestoes(){
    let conteudoPPU;
    if(unidade){
      conteudoPPU = status.conteudoPPU[unidade][menu];
    } else {
      conteudoPPU = status.conteudoPPU[menu];
    }
    //Variável que conta a quantidade de questões nesta posição da Status
    let qtdQuestoes = Object.keys(conteudoPPU[localQuestao]).length - 1;//A subtração de menos 1 é para excluir o primeiro objeto que marca se já foi concluído

    //Grava na STATUS se o usuário acertou a questão e se todas estão corretas conclui o tópico de questões
    if(qtdQuestoes == 1 && idQuestao > 1){
      idQuestao = qtdQuestoes;
    }
    if (conteudoPPU[localQuestao][idQuestao] === false) {
      conteudoPPU[localQuestao][idQuestao] = true;
      //Verifica se o usuário acertou todas as questões de uma página
      conteudoPPU[localQuestao].forEach(questao => {
        if(questao === true) {
          contadorQuestaoCerta++;
        }
      });
      //Grava a conclusão dos itens de questão na página
      if (contadorQuestaoCerta === qtdQuestoes && conteudoPPU[localQuestao][0] === 0) {
        conteudoPPU[localQuestao][0] = 1;
      }

      unasus.pack.setStatus(status);
      /*Função para atualizar a status com LTI e Percentage e marcar o menu sidebar de acordo com a STATUS do PPU*/
      utilizarPPU(link);
      atualizarStatus();
    }
  }
}

/*Função para Atualizar porcentagens, LTI e progresso de variáveis de PPU*/
function atualizarStatus() {
  //Variável que contém uma instância da STATUS
  let status = unasus.pack.getStatus();
  let conteudoPPU = status.conteudoPPU;

  let link = window.location.href.substr(window.location.href.lastIndexOf("#") + 1);
  let navegacao = separarEndereco(link);
  let unidade = navegacao.unidade || "";
  let menu = navegacao.menu;

  //Inicialização de contadores e totais
  let qtdQuestaoCorreta = 0;
  let qtdPagVisitadas = 0;
  let qtdPagTotal = 0;
  let qtdQuestaoTotal = 0; //Contador de todas as páginas de questões existentes
  let somaLTI = 0;
  let porcentagemTotal = 0;
  let arrayQuestoes = [];

  //Marcação de menu Ativo
  $("#sidebar li").removeClass("active");
  $("#sidebar").find("li [data-menu='"+ unidade + menu +"']").parent("li").addClass("active");
  //Collapsa todo os itens do menu
  $(".menu-link a").attr("aria-expanded", false).addClass("collapsed").siblings("ul").attr("aria-expanded", false).removeClass("in");
  //Abre a unidade a qual a pargina navegada pertence
  if(unidade){
    $("#sidebar").find("li.active").parents("li.menu-link").addClass("active");
    $(".menu-link.active > a").attr("aria-expanded", true).removeClass("collapsed").siblings("ul").attr("aria-expanded", true).addClass("in");
  }
  //Correção para ao clicar em páginas de um mesmo menu o manter aberto, mesmo fechando manualmente
  if($(".menu-link.active ul").attr("aria-expanded") === "true"){
    $(".menu-link.active ul").css("height", "auto");
  }
  //Percorre todo o conteudoPPU da STATUS
  let verificarNivel = function (objeto) {
    //Percorre o nível de página
    for (let p in objeto) {
      //Verifica se a página é uma questão e se foi respondida corretamente
      if (objeto[p].length >= 2) {
        arrayQuestoes = objeto[p];
        arrayQuestoes.forEach(questao => {
          if(questao !== 0 && questao !== 1){
            qtdQuestaoTotal++;
          }
          if(questao === 1) {
            qtdPagVisitadas++;
            qtdPagTotal++;
          }
          if(questao === 0) { qtdPagTotal++; }
          if(questao === true){
            qtdQuestaoCorreta++;
          }
        });
      }
      if (objeto[p] === 1) {
        qtdPagVisitadas++;
        qtdPagTotal++;
      }
      if (objeto[p] === 0) {
        qtdPagTotal++;
      }
    }
  };

  //Percorre os ítens do conteudoPPU da STATUS
  for (let m in conteudoPPU) {
    //Percorre o nível de menu
    if(m.startsWith("menu")){
      if(conteudoPPU[m][0] === true){
        let number = m.substring(4,6);
        //Marca o menu de acordo com que já foi visualizado
        $("#sidebar").find(`li a[data-menu="menu${number}"]`).addClass("completo").show();
        //Marca os itens do progresso
        $(".bs-wizard #" + m).addClass("completed").removeClass("disabled");
        $(".bs-wizard #" + m + " a").append("<i class='uil-check'></i>");
      }
      verificarNivel(conteudoPPU[m]);
      continue;
    }
    //Percorre o nível de unidade
    if(m.startsWith("u")){
      let completo = 0, countMenu = 0;
      if(conteudoPPU[m].concluido === true){
        //Marca a unidade de acordo com que já foi visualizado
        if($("#sidebar li [data-menu='"+ m +"menu01']").length){
          $("#sidebar").find("li [data-menu='"+ m + "menu01']").parents("li.menu-link").children("a").addClass("completo").show();
        }
        //Marca os itens do progresso
        $(".bs-wizard #" + m).addClass("completed").removeClass("disabled");
        $(".bs-wizard #" + m + " a").append("<i class='uil-check'></i>");
      }
      for (let u in conteudoPPU[m]){
        if(u.startsWith("menu")){
          countMenu++;
        }
        //Percorre o nível de página
        for (let p in conteudoPPU[m][u]) {
          if(conteudoPPU[m][u][p] === true && menu !== "menu00"){
            $("#sidebar").find("li [data-menu='"+ m + u +"']").addClass("completo").show();
            completo++;
          }
        }
        verificarNivel(conteudoPPU[m][u]);
      }
      //Verifica se todos os menus de uma unidade foram concluídas
      if(countMenu == completo && conteudoPPU[m].concluido === false){
        conteudoPPU[m].concluido = true;
        $("#sidebar").find("li [data-menu='"+ m + "menu01']").parents("li.menu-link").children("a").addClass("completo").show();
      }
      continue;
    }
  }

  somaLTI = (qtdQuestaoCorreta / qtdQuestaoTotal);
  porcentagemTotal = (qtdPagVisitadas / qtdPagTotal) * 100;

  /*Função que envia a porcentagem e o LTI para a inserção na variável de persistência STATUS do PPU utilizando o controllerPPU.js*/
  atualizarPercentageLTI(status, porcentagemTotal, somaLTI);
  /**/

  //Atualiza a barra de progresso
  $(".progress-bar").attr("aria-valuenow", porcentagemTotal).css("width", porcentagemTotal + "%").text(parseInt(porcentagemTotal) + "%");
}

/*Função que monta as páginas conforme se navega na aplicação. Recebe como parâmetro a página que deseja ser carregada na interface de acordo com o objeto e as chaves encontradas no conteudoCurso.json*/
function carregadorPagina(pagina) {
  $('.loaderAjax').show();
  //Caso a página passada seja uma url completa esta váriavel separa a página da url
  let buscarPagina = pagina.substr(pagina.lastIndexOf("#") + 1);
  //Não são admitidos links vazios para não compremeter o histórico de navegação
  if (buscarPagina == "") {
    return false;
  } else {
    //Ativa a função que rastreia as páginas no PPU via controllerPPU.js
    rastrearPagina();
    //Esvazia a div onde se carrega o conteúdo via Ajax
    $("#paginaConteudo").empty();
    //Carregamento de Json que renderiza o conteúdo
    $.getJSON("assets/json/conteudoCurso.json", function (json) {
      let contPrincipal, carregar;

      let navegacao = separarEndereco(buscarPagina);
      let unidade = navegacao.unidade;
      let menuPagina = navegacao.menu;
      let carregarPagina = navegacao.pagina;

      if(unidade === undefined){
        contPrincipal = json.conteudoPrincipal;
      } else {
        contPrincipal = json.conteudoPrincipal[unidade];
      }

      carregar = contPrincipal[menuPagina][carregarPagina];
      //Contador de Páginas do Menu
      let contador = 0;
      //Laço que incrementa número de Páginas dentro de um menu
      for (let p in contPrincipal[menuPagina]) {
        if (p.startsWith("pagina")) {
          contador++;
        }
      }
      /*Preenche as informações da parte superior da página, titulo e quantidade só são recarregados na mudança de menu*/
      $("#tituloPagina").attr("data-local", unidade || menuPagina).html(`<p>${contPrincipal[menuPagina].subtitulo}</p><h5>${contPrincipal[menuPagina].titulo}</h5>`);
      //Pega o número final da página para preencher o indicador de página atual
      if (menuPagina === "menu00") {
        $("#numPagina").html(" ");
      }
      else {
        $("#numPagina").html('<small>Página</small> <strong>' + (carregarPagina.substring(6, 9) < 10 ? carregarPagina.substring(7, 9) : carregarPagina.substring(6, 9)) + '</strong> / <span class="text-gray">' + contador + '</span>');
      }
      //Laço que preenche a página com os elementos
      let x, componente, nomeComponente;
      for (x in carregar) {
        componente = criarComponente(json, buscarPagina, x);
        nomeComponente = x.split(/[0-9]/)[0];//Regex para excluir números
        /*Criação dos Componentes baseados nos dados preenchidos no conteudoCurso.json e no componentMaker.js*/
        if (nomeComponente && componente[nomeComponente] instanceof Function) {
          componente[nomeComponente]();
        } else {
          console.warn(`O componente "${nomeComponente}" enviado não é um componente válido para o ComponentMaker.`);
        }
      }//Fim do laço que cria os componentes
      //Verifica após criado todos os componentes se existe player de áudio e ativa o js do player de áudio
      if($(".audioComponent").length){
        playerAudioUNASUS();
      }
      //Verifica após criado todos os componentes se existe escala(range) e ativa o js do rangeReviewColor.js
      if($(".bloco-range").length){
        var optionRangeSmiley = [
          {min:0,max:30,icon:'icon-frown'},
          {min:30,max:70,icon:'icon-meh'},
          {min:70,max:100,icon:'icon-smiley'}
        ],
        theme = 'satisfied';
        $('.statisfied').RangeReviewColor(optionRangeSmiley,theme);
      }
      //Verifica após criado todos os componentes se existe um chat automatizado e ativa o js do jquery.Conversas.js
      if($(".bloco-conversas").length){
        $('.bloco-conversas').Conversas();
      }
      //Verifica as variáveis do PPU
      utilizarPPU(buscarPagina);
      //Após o carregamento do ajax da página o loader é escondido
      $('.loaderAjax').hide();
    });
  }
  /*Verifica qual navegador está sendo usado pois a codificação da navegação do onPopState é diferente entre o Firefox e os outros navegadores.*/
  //Verifica se o navegador é Firefox
  if (navigator.userAgent.toLowerCase().indexOf("firefox") > -1) {
    //Implementação de onPopState para o firefox que executa ele da maneira correta somente ao acionar os botões do navegador.
    window.onpopstate = function () {
      let link = window.location.href.substr(window.location.href.lastIndexOf("#") + 1);
      //Elimina links vazios
      if (link !== "") {
        //Chama a função que carrega a pagina correspondente ao histórico do navegador
        carregadorPagina(window.location.href);
      } else {
        return false;
      }
    };
    window.onhashchange = function () {
      console.log('The hash has changed!');
    };
  } else {
    //Implementação para verificar a mudança de hash para navegação de todos os outros navegadores incluindo IE 11 e Edge
    window.onhashchange = function () {
      let link = window.location.href.substr(window.location.href.lastIndexOf("#") + 1);
      //Elimina links vazios
      if (link !== "") {
        //Chama a função que carrega a pagina correspondente ao histórico do navegador
        carregadorPagina(link);
      } else {
        return false;
      }
    };
  }
}

/*Função para carregar os dados das modais utilizando o conteudoCurso.json. Não recebe parâmetro inserindo as informações em cada modal dinamicamente*/
function carregarModal() {
  //Função do bootstrap que identifica se a modal foi aberta
  $('.modal').on('show.bs.modal', function (e) {
    $('.loaderAjaxModal').show(); //Habilita a imagem que mostra o loading em conexões lentas
    let link = $(e.relatedTarget);
    let id = link.data("conteudo");
    let item = link.data("item");
    let modal = $(this);
    $(".modal-body").empty(); //Esvazia a div onde se carrega o conteúdo
    $(".modal-filter").remove();
    //Retira as classes que fazem a modal ficar fluida na tela
    modal.removeClass("modal-with-sidebar modal-fullscreen");
    modal.find(".modal-dialog").removeClass("modal-lg");
    modal.find(".modal-body").removeClass("pos-relative");
    modal.find(".modal-dialog").removeAttr("id");//Retira o id de uma modal
    //Carregamento de Json
    $.getJSON("assets/json/conteudoCurso.json", function (json) {
      let carregar = json.modal[id];
      let tipoModal = {
        palavra(){
          carregar = json.modal.glossario;
          modal.find(".modal-header h4").text("Glossário");
          for (let x in carregar) {
            if (x.startsWith("termo")) {
              if (carregar[x].id === item) {
                modal.find(".modal-body").append(`<p id="${carregar[x].id}"><strong>${carregar[x].termo}: </strong>${carregar[x].descricao}</p>`);
              }
            }
          }
        },
        objetivos(){
          modal.find(".modal-header h4").text(carregar.tituloModal);
          modal.find(".modal-body").append(carregar.titulo ? `<h4>${carregar.titulo}</h4>` : "");
          modal.find(".modal-body").append(`<p>${carregar.meta}</p><ul class="objetivos"></ul>`);
          for (let x in carregar) {
            if (x.startsWith("objetivo")) {
              modal.find(".objetivos").append(`<li>${carregar[x]}</li>`);
            }
          }
        },
        glossario(){
          modal.find(".modal-header h4").text(carregar.tituloModal);
          //Adiciona as classes que fazem a modal ficar fluida na tela
          modal.find(".modal-dialog").addClass("modal-lg");
          modal.find(".modal-body").addClass("pos-relative");
          modal.find(".modal-body").append(carregar.titulo ? `<h4>${carregar.titulo}</h4>` : "");
          for (let x in carregar) {
            if (x.startsWith("termo")) {
              modal.find(".modal-body").append(`<div id="${carregar[x].id}" class="mt-md mb-md"><strong>${carregar[x].termo}: </strong>${carregar[x].descricao}</div><div class="divider-top"></div>`);//Cria um divisor nos elementos do glossário
            }
          }
          modal.find(".modal-body .divider-top:last-child").remove();
        },
        leituras(){
          modal.find(".modal-header h4").text(carregar.tituloModal);
          //Json com o conteúdo principal
          let x, y, local, titulo, subtitulo, conteudoPrincipal = json.conteudoPrincipal;
          //Adiciona as classes que fazem a modal ficar fluida na tela
          modal.find(".modal-dialog").addClass("modal-lg");
          modal.find(".modal-body").addClass("pos-relative");
          modal.find(".modal-body").append(carregar.titulo ? `<h4>${carregar.titulo}</h4>` : "");
          //Criação do input para a busca
          if (!$(".modal-filter").length) {//Verifica se o filtro já foi criado
            modal.find(".modal-header").after('<div class="modal-filter"></div>');
          }
          modal.find(".modal-filter").html(
            `<div class="row">
              <div class="col-xs-12">
                <div class="form-group">
                  <input type="search" class="form-control input-sm search" placeholder="Digite o que procura">
                </div>
              </div>
            </div>`
          );
          //Criação de accordion para separar por tópicos
          modal.find(".modal-body").append(
            `<div class="row mt-md">
              <div class="col-lg-12">
                <div class="panel-group collapse-theme-one" id="accordion${id}"></div>
              </div>
            </div>`
          );
          for (x in carregar) {
            if (x.startsWith("leitura")) {
              local = carregar[x].tituloTopico;
              if (conteudoPrincipal[local].tituloUnidade !== undefined){
                titulo = conteudoPrincipal[local].tituloUnidade;
                subtitulo = conteudoPrincipal[local].menu01.subtitulo;
              } else {
                titulo = conteudoPrincipal[local].titulo;
                subtitulo = conteudoPrincipal[local].subtitulo;
              }
              modal.find("#accordion" + id).append(
                `<div class="panel panel-default">
                  <div class="panel-heading">
                    <h5 class="panel-title">
                      <a class="accordion-toggle collapsed leitura_${local}" data-toggle="collapse" data-parent="#accordion${id}" href="#${x}">
                        ${subtitulo !== "" ? subtitulo +" - " : "" }${titulo}
                      </a>
                    </h5>
                  </div>
                  <div id="${x}" class="panel-collapse collapse">
                    <div class="panel-body"></div>
                  </div>
                </div>`
              );
              for (y in carregar[x]) {
                if(y.startsWith("link")){
                  modal.find("#" + x + " .panel-body").append(`<p class="mt-md" data-leitura=${y}>${carregar[x][y]}</p><div class="divider-top"></div>`);
                }
              }
              modal.find("#" + x + " .panel-body .divider-top:last-child").remove();
            }
          }
        },
        leituraRecomendada(){
          this.leituras();
        },
        leituraComplementar(){
          this.leituras();
        },
        creditos(){
          modal.find(".modal-header h4").text(carregar.tituloModal);
          //Adiciona as classes que fazem a modal ficar fluida na tela
          modal.find(".modal-dialog").attr("id", id).addClass("modal-lg");
          modal.find(".modal-body").addClass("pos-relative");
          for (let x in carregar) {
            if (x.startsWith("titulo") && x !== "tituloModal"){
              modal.find(".modal-body").append(`<h4 class="${x}">${carregar[x]}</h4>`);
              continue;
            }
            if (x.startsWith("texto")){
              modal.find(".modal-body").append(`<p class="${x}">${carregar[x]}</p>`);
              continue;
            }
            if (x.startsWith("area")){
              modal.find(".modal-body").append(`<p class="areaAtuacao ${x}"></p>`);
              for(let y in carregar[x]){
                if(y.startsWith("titulo")){
                  modal.find(".modal-body .areaAtuacao." + x).append(`<b class="${x}">${carregar[x][y]}</b>`);
                  continue;
                }
                if(y.startsWith("item")){
                  modal.find(".modal-body .areaAtuacao." + x).append(`<br><i>${carregar[x][y]}</i>`);
                  continue;
                }
              }
            }
          }
        },
        guiaAluno(){
          modal.addClass('modal-with-sidebar modal-fullscreen');
          modal.find(".modal-header h4").text(carregar.tituloModal);
          //Adiciona as classes que fazem a modal ficar fluida na tela
          modal.find(".modal-dialog").attr("id", id).addClass("modal-lg");
          modal.find(".modal-body").addClass("pos-relative");
          modal.find(".modal-body").append('<div class="row"><button title="Fechar navegação lateral" class="toggle-sidebar-sidebar sidebarCollapse btn-hideMenu open" type="button"><i class="uil-bars"></i><i class="uil uil-multiply"></i></button><div class="col-sm-5 col-md-3"><nav class="navbar navbar-default nav-modal"><div class="container-fluid"><div class="navbar-header"><button type="button" class="navbar-toggle collapsed" data-toggle="collapse"data-target="#bs-example-navbar-collapse-1" aria-expanded="false"><span class="icon-bar"></span><span class="icon-bar"></span><span class="icon-bar"></span></button></div><div class="collapse navbar-collapse" id="bs-example-navbar-collapse-1"><ul class="nav navbar-nav" role="tablist"></ul></div></div></nav></div><div class="col-sm-7 col-md-9 modal-conteudo"><button class="btn btn-default btn-xs btn-anteriorPagina" style="display: none;" title="Voltar para a página anterior"><i class="uil-angle-left"></i></button><div class="tab-content"></div><button class="btn btn-default btn-xs icon-content text-right btn-proximaPagina" title="Ir para a próxima página"><i class="uil-angle-right"></i></button></div></div>');

          modal.find('.btn-hideMenu').on('click', function() {
            const $this = $(this);

            if ($this.hasClass('open')) {
              $this.removeClass('open');
              modal.find('.navbar.nav-modal').parent().hide();
              modal.find('.btn-anteriorPagina').addClass('menuCollapse');
              modal.find('.col-md-9.col-sm-7').removeClass('col-md-9 col-sm-7').addClass('col-md-12 col-sm-12');
            } else {
              $this.addClass('open');
              modal.find('.btn-anteriorPagina').removeClass('menuCollapse');
              modal.find('.navbar.nav-modal').parent().show();
              modal.find('.col-md-12.col-sm-12').removeClass('col-md-12 col-sm-12').addClass('col-md-9 col-sm-7');
            }
          });
          for (let x in carregar){
            if (x.startsWith("titulo") && x !== "tituloModal"){
              modal.find(".modal-body").prepend(`<div class="${x}-mc"><h4>${carregar[x]}</h4></div>`);
              continue;
            }
            if (x.startsWith("tela")){
              modal.find('.modal-conteudo .tab-content').append(`<div role="tabpanel" class="tab-pane ${x.startsWith("tela01") ? 'active' : ''}" id="${x}"><div class="telaGuia ${x}"></div></div>`);
              for(let y in carregar[x]){

                if(y.startsWith("titulo") && carregar[x][y] !== ""){
                  modal.find(".modal-body .telaGuia." + x).append(`<div class="${y}"><p><b>${carregar[x][y]}</b></p></div>`);
                  modal.find(".modal-body .nav.navbar-nav").append(`<li role="presentation" class="${x.startsWith("tela01") ? 'active' : ''}"><a href="#${x}" aria-controls="${x}" role="tab" data-toggle="tab">${carregar[x][y]} <span class="sr-only">(current)</span></a></li>`);
                  continue;
                }
                if (y.startsWith("texto")){
                  modal.find(".modal-body .telaGuia."+x).append(`<div class="${y}"><p>${carregar[x][y]}</p></div>`);
                  continue;
                }
                if(y.startsWith("imagem")){
                  modal.find(".modal-body .telaGuia."+x).append(`<div class="imagem"><img alt="${carregar[x][y].alt}" class="img-adaptative" src="${carregar[x][y].endereco}"/></div>`);
                  continue;
                }
              }
            }
          }

          if (carregar.pdf) {
            let endereco = carregar.pdf;
            let nomeArquivo = endereco.substring(endereco.lastIndexOf("/") + 1);
            modal.find(".modal-body").append(`<div class="download-pdf"><a class='downloadArquivo' title='Faça o download do guia de navegação deste curso em PDF' href='${carregar.pdf}' download="${nomeArquivo}"><i class="uil uil-file-download"></i> Baixar PDF - Guia de Navegação<\/a></div>`);
          }

          modal.find(".btn-proximaPagina").on('click', function() {
            const proximaLi = modal.find('.nav.navbar-nav li.active').next();
            proximaLi.find('a').click();
            modal.find(".btn-anteriorPagina").show();

            if (!proximaLi.next().length) {
              $(this).hide();
            }
          });

          modal.find(".btn-anteriorPagina").on('click', function() {
            const anteriorLi = modal.find('.nav.navbar-nav li.active').prev();
            anteriorLi.find('a').click();
            modal.find(".btn-proximaPagina").show();

            if (!anteriorLi.prev().length) {
              $(this).hide();
            }
          });
        },
        conteudoExtra(){
          modal.find(".modal-header h4").text(e.relatedTarget.text);
          let componente, nomeComponente, conteudoExtra = json.modal.conteudoExtra;
          //Adiciona as classes que fazem a modal ficar fluida na tela
          modal.find(".modal-dialog").attr("id", id).addClass("modal-lg");
          modal.find(".modal-body").addClass("pos-relative");
          componente = criarComponente(conteudoExtra, "modal");
          nomeComponente = item.split(/[0-9]/)[0];//Regex para excluir números
          /*Criação dos Componentes baseados nos dados preenchidos no conteudoCurso.json e no componentMaker.js*/
          if (nomeComponente && componente.conteudoExtra instanceof Function) {
            componente.conteudoExtra(id, item);
          } else {
            console.warn(`O componente "${nomeComponente}" enviado não é um componente válido para o ComponentMaker.`);
          }
        }
      };
      if (tipoModal && tipoModal[id] instanceof Function) {
        tipoModal[id]();
        modal.find(".modal-body").append("<div class='fecharModal text-right'><button data-dismiss='modal' aria-label='Close'>Fechar [X]</button></div>");//Cria um botão extra de fechamento da modal
        $('.loaderAjaxModal').hide(); //Desabilita a imagem que mostra o loading em conexões lentas
      } else {
        console.warn(`Não existe modal para "${id}".`);
      }
    });
  });
  //Código para que os links de leitura complementar abram o tópico a qual pertencem e está conectado ao texto do tópico da página
  $(".modal").on("shown.bs.modal", function (e) {
    if ($("#accordionleituraComplementar").is(":visible")) {
      let link = $(e.relatedTarget);
      let item = link.data("item");
      let leitura = link.data("leitura");
      $(".leitura_" + item).trigger("click");
      $(".leitura_" + item).parents(".panel-default").find(".panel-body [data-leitura='"+ leitura +"']").addClass("destaqueLeitura");
    }
  });
  //Código para limpar o conteúdo da modal ao fechar
  $(".modal").on("hide.bs.modal", function () {
    $(".modal .modal-body").empty();
  });
  //Verifica as letras digitadas independentes de maiúsculas ou minúsculas
  $.expr[':'].containsCaseInsensitive = function (n, i, m) {
    return jQuery(n).text().toUpperCase().indexOf(m[3].toUpperCase()) >= 0;
  };
  //Abre todos o accordions para começar a filtragem por letra
  $(document).on("click", ".search", function () {
    $(".modal-body .accordion-toggle").removeClass("collapsed");
    $(".modal-body .panel-collapse").addClass("in");
    $(".modal-body").find(".accordion-toggle").attr("aria-expanded", true);
    $(".modal-body").find(".panel-collapse").attr("aria-expanded", true).css("height", "auto");
  });
  //Verifica o input da busca fazendo a filtragem retirando os itens que não batem com o texto digitado
  $(document).on("change keyup paste click", ".search", function () {
    //Código para filtrar os dados buscando por letra digitada utilizando o input
    let searchTerm, panelContainerId;
    searchTerm = $(this).val();
    $("#accordionleituraRecomendada > .panel, #accordionleituraComplementar > .panel").each(function () {
      panelContainerId = '#' + $(this).children(".panel-collapse").attr('id');
      $(panelContainerId + ':not(:containsCaseInsensitive(' + searchTerm + '))').removeClass("in").hide();//Oculta as linhas que não contém o objeto buscado.
      $(panelContainerId + " .panel-body p" + ':not(:containsCaseInsensitive(' + searchTerm + '))').hide();
      $(panelContainerId + ':containsCaseInsensitive(' + searchTerm + ')').addClass("in").show();//Mostra as linhas que conferem
      $(panelContainerId + " .panel-body p" + ':containsCaseInsensitive(' + searchTerm + ')').show();
    });
  });
}

/*Função para carregar a estrutura do curso e a navegação utilizando a navegacaoPrincipal.json. Não recebe parâmetro montando os menus e topo na tela dinamicamente*/
function carregarEstrutura() {
  $('.loaderAjaxEstrutura').show(); //Habilita a imagem que mostra o loading em conexões lentas
  let menu, sup, count = 0, quantidadeMenu = 0;
  //Carregamento de Json
  $.getJSON("assets/json/navegacaoPrincipal.json", function (json) {
    menu = json.menuLateral;
    sup = json.menuSuperior;
    //Monta os menus e topo
    $(".menu-sidebar").append("<ul class='list-unstyled components menuPrincipal'></ul>");
    //Monta o título do curso
    $("#tituloCurso").html(sup.tituloCurso);
    //Monta os links do menu superior
    quantidadeMenu = sup.qtdMenuMostrados || 4;//Quantidade de menus para aparecer o botão mais
    for (let z in sup) {
      if (z.substring(0, 4) === "link") {
        if (count < quantidadeMenu) {
          count++;
          if(sup[z].modal){
            $("#menuSuperior").append(
              "<li>" +
                "<a data-toggle='modal' "+ "data-target='" + sup[z].endereco + "'  title='" + sup[z].title + "' data-conteudo='" + sup[z].modal + "'>" + sup[z].texto + "</a>"+
              "</li>"
            );
          } else {
            $("#menuSuperior").append(
              "<li>" +
                "<a class='downloadArquivo' href='" + sup[z].endereco + "' title='" + sup[z].title + "' download='" + sup[z].texto + "'>" + sup[z].texto + "</a>"+
              "</li>"
            );
          }
        } else {
          if (!$("#menuSuperior li.dropdown").length) {
            $("#menuSuperior").append(
              '<li class="dropdown">' +
              '<a href="#" class="dropdown-toggle" data-toggle="dropdown">Mais<b class="caret"></b></a>' +
              '<ul class="dropdown-menu"></ul>' +
              '</li>'
            );
          }
          if(sup[z].modal){
            $("#menuSuperior ul.dropdown-menu").append(
              "<li>" +
                "<a data-toggle='modal' "+ "data-target='" + sup[z].endereco + "'  title='" + sup[z].title + "' data-conteudo='" + sup[z].modal + "'>" + sup[z].texto + "</a>"+
              "</li>"
            );
          } else {
            $("#menuSuperior ul.dropdown-menu").append(
              "<li>" +
                "<a class='downloadArquivo' href='" + sup[z].endereco + "' title='" + sup[z].title + "' download='" + sup[z].texto + "'>" + sup[z].texto + "</a>"+
              "</li>"
            );
          }
        }
      }
    }
    let menuLateral = {
      link(id, objeto, montar){
        let navegacao, endUnidade, endMenu;
        let local = (montar === undefined ? ".menuPrincipal ."+ id : montar);
        for(let x in objeto){
          if(x.startsWith("link")){
            navegacao = separarEndereco(objeto[x].endereco);
            endUnidade = navegacao.unidade || "";
            endMenu = navegacao.menu;
            $(local).append(`${montar !== undefined ? `<li><a href="${objeto[x].endereco}" title="${objeto[x].title}" class="carregarPagina ${x}" data-menu="${endUnidade + endMenu}">${objeto[x].texto}</a></li>` : `<a href="${objeto[x].endereco}" title="${objeto[x].title}" class="carregarPagina ${x}" data-menu="${endUnidade + endMenu}">${objeto[x].texto}</a>`}`);
          }
        }
      },
      submenu(id, objeto){
        for(let x in objeto){
          if(x !== "titulo"){
            //2 níveis
            if(!x.startsWith("submenu") && !$("#submenu_"+ id).hasClass("nivel3")){
              if(!$("#submenu_" + id).length){
                $(".menuPrincipal ."+ id).append(
                  `<a href="#submenu_${id}" data-toggle="collapse" aria-expanded="false" title="Clique para acessar os itens de ${objeto.titulo}"><i class="uil uil-angle-right"></i>${objeto.titulo}</a>
                  <ul class="collapse list-unstyled nivel2" id="submenu_${id}"></ul>`
                );
                this.link(x, objeto, "#submenu_"+ id +".nivel2");
              }
              continue;
            }
            //3 níveis
            if(x.startsWith("submenu")){
              if(!$("#submenu_"+ id).length){
                $(".menuPrincipal ."+ id).append(
                  `<a href="#submenu_${id}" data-toggle="collapse" aria-expanded="false" title="Clique para acessar os itens de ${objeto.titulo}"><i class="uil uil-angle-right"></i>${objeto.titulo}</a>
                  <ul class="collapse list-unstyled nivel3" id="submenu_${id}"></ul>`
                );
              }
              $("#submenu_"+ id).append(
                `<li>
                  <a href="#itens_${id + x}" data-toggle="collapse" aria-expanded="false" title="Clique para acessar os itens de ${objeto[x].subtitulo}"><i class='uil uil-angle-right'></i>${objeto[x].subtitulo}</a>
                  <ul class="collapse list-unstyled" id="itens_${id + x}"></ul>
                </li>`
              );
              this.link(x, objeto[x], "#itens_"+ id + x);
              continue;
            }
            //3 níveis com link simples
            if($("#submenu_"+ id).hasClass("nivel3") && x.startsWith("link")) {
              this.link(x, objeto, "#submenu_"+ id);
            }
          }
        }
      }
    };
    //Monta o menu Lateral onde pode existir 1, 2 e 3 níveis de navegação
    for (let x in menu) {
      $(".menuPrincipal").append(`<li class="menu-link ${x}"></li>`);
      let titulo = menu[x].titulo;
      let submenu = Object.keys(menu[x]).some(item => item.startsWith("submenu"));
      //Menu 1 nível
      if (!titulo) {
        menuLateral.link(x, menu[x]);
        continue;
      }
      //Menu de 2 e 3 níveis
      if(titulo || submenu){
        menuLateral.submenu(x, menu[x]);
        continue;
      }
    }
    $('.loaderAjaxEstrutura').hide(); //Desabilita a imagem que mostra o loading em conexões lentas
  });
  //Código para fechar os outros menus e submenus de 2 e 3 níveis
  $(document).on("click", ".menu-link a", function (){
    let nivel2 = $(this).siblings("ul").children("li").children("ul");
    let nivel3 = $(this).parent().siblings("li").children("ul");
    if (nivel2.is(":visible")) {
      nivel2.collapse("hide");
    }
    if (nivel3.is(":visible")) {
      nivel3.collapse("hide");
      //Condicional para fechar os menus de 3 níveis
      if (nivel3.children("li").children("ul").is(":visible")) {
        nivel3.children().children("ul").collapse("hide");
      }
    }
  });
}
/*Função que é executada quando a página e seus componentes forem totalmente carregados*/
function carregarSite() {
  $("body").addClass("loaded");
  //Fix para sumir elemento na animação de saída
  $("#loader-wrapper p").hide();
  //Identificador de primeiro carregamento na Session Storage
  sessionStorage.setItem("firstLoading", false);
}

/*Função que cria Drag and Drops de acordo com o tipo recebido por JSON*/
//Foi usados os plugins https://jqueryui.com/draggable/ e https://github.com/furf/jquery-ui-touch-punch para eventos em aparelhos touch
function criarDragndrop(dragnDrop) {
  let tipo = dragnDrop.tipo;
  $("#paginaConteudo").append(
    `<div data-componente="${tipo}" class="dragnDrop bloco-atividade mt-lg">
      <div class="row">
        <div class="col-md-12">
          <div class="panel panel-default">
            ${dragnDrop.enunciado ? `<div class="col-md-12 enunciadoTexto">
              <div class="bloco-texto">${dragnDrop.enunciado}</div>
            </div>` : ""}
            <div class="col-md-12 panel-body">
              <div class="${tipo}" data-questionario="${dragnDrop.questionario}" data-questao="${dragnDrop.questao}"></div>
            </div>
          </div>
        </div>
      </div>
    </div>`
  );//Cria um componente no projeto do tipo DragnDrop

  /*Funções Essenciais*/
  /*Função que muda os itens renderizados em HTML de posição randomicamente */
  $.fn.trocarPosicaoHTML = function(){
    $.each(this.get(), function(index, el) {
      var $el = $(el);
      var $find = $el.children();
      $find.sort(function() { return 0.5 - Math.random(); });
      $el.empty();
      $find.appendTo($el);
    });
    tornarDrag();
  };
  /*Função que transforma os itens arrastáveis utilizando a biblioteca de transformação de draggable do jQueryUI */
  function tornarDrag(){
    $(".itemDrag").draggable({
      revert: function (droppableContainer) {
        if (droppableContainer) {
          // drop is valid
        } else {
          montarModal(tipo, "Tente novamente!");
          // drop is invalid
          return (!droppableContainer); //returns the draggable to its original position
        }
      },
      drag: function () {
        $(this).css("cursor", "grabbing");
      },
      stop: function () {
        $(this).css("cursor", "grab");
      }
    });
  }
  /*Função criada para montagem de Drag n Drop de acordo com JSON*/
  function montarDragnDrop(random, custom) {
    if(custom){
      $("."+ tipo).append(custom);
    } else {
      $("."+ tipo).append('<div id="dragContainer" class="areaDrag dragContainer"></div><div class="dropContainer"></div>');
    }
    let itens = [];
    for (let drop in dragnDrop) {
      if (Object.hasOwnProperty.call(dragnDrop, drop) && drop.startsWith("drop")) {
        $("."+ tipo +" .dropContainer").append('<div id="' + dragnDrop[drop].areaDrop + '">'+ (dragnDrop[drop].titulo ? '<span>'+ dragnDrop[drop].titulo +'</span>' : "") +'</div>');
        $('#' + dragnDrop[drop].areaDrop).append(dragnDrop[drop].texto);
        verificarDrop(drop);
        for (let y in dragnDrop[drop]){
          if (y.substring(0, 4) === "drag"){
            itens.push([y, dragnDrop[drop][y]]);
          }
        }
        if(random){
          //Código para randomizar as áreas do drop
          itens.sort(function () { return (Math.round(Math.random()) - 0.5); });
        }
        //Laço que renderiza na tela as opções que foram randomizadas ou não
        for (let i = itens.length - 1; i >= 0; i--){
          $("#" + dragnDrop[drop].id).append('<div class="itemDrag ' + itens[i][1].classe + '" data-type="' + dragnDrop[drop].areaDrop + '" data-item="'+ itens[i][0] +'">' + itens[i][1].texto + '</div>');
        }
      }
      itens = [];
    }
    $(".dropContainer div").append('<ul></ul>');
    tornarDrag();
  }
  function verificarDrop(drop) {
    //Informa as áreas que são dropavéis e qual a resposta é aceita
    $("#"+ dragnDrop[drop].areaDrop).droppable({
      accept: "[data-type='"+ dragnDrop[drop].areaDrop +"']",
      drop: function (ev, ui) {
        let itemCorreto = $(ui.draggable).html();
        let idItem = $(ui.draggable).data("item");
        $(this).children("ul").append("<li>" + itemCorreto + "</li>");
        $(ui.draggable).remove();
        if(dragnDrop[drop][idItem].feedback){
          montarModal(tipo, dragnDrop[drop][idItem].feedback);
        }
        verificarConclusao();
      }
    });
  }
  /*Fim Funções Essenciais*/

  /*Tipos de drag'ndrop*/

  if (tipo === "drag2colunas") {
    montarDragnDrop("random");
    let dragItens = $("."+ tipo +" .dragContainer");
    $(dragItens).trocarPosicaoHTML();
  }

  //Verifica se o DragnDrop foi finalizado
  function verificarConclusao(){
    if($("."+ tipo +" .dragContainer").is(":empty")){
      let formulario = $("." + tipo);
      $("."+ tipo +" .dragContainer").remove();
      verificarGabarito(tipo, "dragndrop", formulario);
    }
  }
}

/*Função que monta uma modal sobre componentes, recebe o componente e a mensagem apresentada na modal como parâmetros*/
function montarModal(componente, mensagem) {
  if (!$("#modalComponente").length) {
    $("[data-componente='"+ componente +"']").prepend('<div class="dragBack"></div><div id="modalComponente"></div>');
  }
  $("#modalComponente").html(
    '<div class="respostaModal" tabindex="-1" role="dialog">'+
      '<div class="modal-dialog">'+
        '<div class="modal-content">'+
          '<div class="modal-body">'+
            '<p>' + mensagem + '</p>'+
          '</div>'+
          '<div class="modal-footer">'+
            '<button type="button" class="btn btn-primary closeModal" data-dismiss="modal">Fechar</button>'+
          '</div>'+
        '</div>'+
      '</div>'+
    '</div>');
  $('#modalComponente .respostaModal').modal({ "show": false, "backdrop": false, "focus": false });
  $("body").removeClass("modal-open");
}